#!/usr/local/bin/perl
require 5.004;
use strict;
#-------------------------------------------------------------------------------
# ե륢åץ
#						(C)2006 nabe / ABK project
#-------------------------------------------------------------------------------
package Satsuki::Uploader;
#-------------------------------------------------------------------------------
our $VERSION = '1.00';
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my ($class, $ROBJ) = @_;
	my $self = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ

	$self->{ROBJ}     = $ROBJ;	# root object save

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# ᥤ
###############################################################################
sub main {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $DB   = $ROBJ->{DB};

	$ROBJ->read_form();		# եɤ߹
	$ROBJ->get_cookie();		# cookieɤ߹
	my $cookie      = $ROBJ->{Cookie};

	#-------------------------------------------------------------
	# Cookie  Authorization 
	#-------------------------------------------------------------
	my $auth = $ROBJ->{Auth};
	my $session = $cookie->{session};
	if (ref $session eq 'HASH') {	# 󥻥å
		$auth->session_auth($session->{id}, $session->{sid});
		$ROBJ->make_csrf_check_key($session->{sid});
	}
	# Ģγǧ
	if (! $auth->{ok}) {
		return $self->error("Not login");
	}

	#-------------------------------------------------------------
	# ȥ PATH (URL) ù
	#-------------------------------------------------------------
	my $pinfo = $ROBJ->read_path_info();	# PATH_INFOɤ߹
	# 裱 : diary_id
	my $diary_id = $self->{diary_id} = shift(@$pinfo);
	$diary_id =~ s/\W//g;
	$self->{diary_id} = $diary_id;
	# Ģγǧ
	if (!$DB->find_table("${diary_id}_diary")) {
		return $self->error('Can not find daybook "%s"', $diary_id);
	}

	#-------------------------------------------------------------
	# ³ǧ
	#-------------------------------------------------------------
	my $auth_id = $auth->{id};
	if ($diary_id ne $auth_id && !$auth->{admin}) {
		my $Diary = $ROBJ->{diary};
		my $file  = $ROBJ->get_filepath($Diary->{setting_dir} . $diary_id . $Diary->{file_ex});
		my $set   = $ROBJ->fread_hash_cached($file);

		my $flag = 1;
		my @edit_users = split(/\s*,\s*/, $set->{edit_users});
		foreach(@edit_users) {
			if ($_ eq $auth_id) { $flag=0; last; }
		}
		if ($flag) {
			return $self->error("Operation not permitted");
		}
	}

	#-------------------------------------------------------------
	# ڡ
	#-------------------------------------------------------------
	my $skelton = $self->{form_skelton};
	if ($ROBJ->{POST}) {
		$skelton = $self->{response_skelton};
	}

	$self->output_html($skelton);
	return 0;
}

###############################################################################
# ɽ
###############################################################################
#------------------------------------------------------------------------------
# HTMLȽ
#------------------------------------------------------------------------------
sub output_html {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($skelton) = @_;

	my $out = $ROBJ->call($skelton);
	$ROBJ->print_content_type($self->{content_type} || "text/html");
	$ROBJ->output_array($out);	# HTML
}

#------------------------------------------------------------------------------
# 顼ɽƽλ
#------------------------------------------------------------------------------
sub error {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	$ROBJ->message(@_);
	$self->output_html( $self->{error_skelton} );
	return 1;
}

###############################################################################
# ȥѥ֥롼
###############################################################################
#------------------------------------------------------------------------------
# åץɽ
#------------------------------------------------------------------------------
sub upload {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my $form = $ROBJ->{Form};

	my $form_file = $form->{data};
	my $file_name = $form_file->{file_name};
	my $file_size = $form_file->{file_size};
	my $tmp_file  = $form_file->{tmp_file};		# ɤ߹եǡ(tmp file)
	if ($file_name eq '' || $file_size < 1) {
		$ROBJ->message("upload file error");
		return 2;
	}
	# ĥҥå
	my $allow_ex     = $self->{allow_ex};
	my $allow_etc_ex = $self->{allow_etc_ex};	# ʳ
	my $is_image;
	my $file_ex;
	if ($file_name =~ /\.([^\.]+)$/) { $file_ex = $1; }
	if ($allow_ex || $allow_etc_ex) {
		my $flag = 1;
		foreach(@$allow_ex) {
			if ($file_ex eq $_) { $flag=0; last; }
		}
		if ($flag) {
			foreach(@$allow_etc_ex) {
				if ($file_ex eq $_) { $flag=0; last; }
			}
		} else {
			$is_image = 1;
		}
		if ($file_ex eq '' || $flag) {
			$ROBJ->message("file extension error (%s)", $file_ex);
			return 3;
		}
	}

	# ե¸ǥ쥯ȥ
	my $diary_id = $self->{diary_id};
	if ($diary_id eq '') { $ROBJ->message("Internal Error"); return -1; }
	my $dir = $self->{image_dir};
	$ROBJ->mkdir($dir);
	$dir .= $diary_id . '/';
	$ROBJ->mkdir($dir);
	my $subdir;
	my $pinfo = $ROBJ->{Pinfo};
	if ($#$pinfo < 3) {
		foreach(@$pinfo) {
			$_ =~ s/\W//g;
			if ($_ eq '') { last; }
			$dir    .= "$_/";
			$subdir .= "$_/";
			$ROBJ->mkdir($dir);
		}
	}

	# ե¸
	$file_name =~ s/^\.+//;		# Ƭ . 
	my $save_file      = $dir . $file_name;
	my $save_file_real = $ROBJ->get_filepath( $save_file );
	if (-e $save_file_real) {	# Ʊե뤬¸ߤ
		$ROBJ->message('Save failed ("%s" already exists)', $file_name);
		return 10;
	}
	my $fail;
	if ($tmp_file) {
		if (! rename($tmp_file, $save_file_real)) { $fail=1; }
	} else {
		if ($ROBJ->fwrite_lines($save_file, $form_file->{data})) { $fail=1; }
	}
	if ($fail) {	# ¸
		$ROBJ->message('Save failed'); return -2;
	}
	#----------------------------------------------------------------------
	# ѿ¸
	#----------------------------------------------------------------------
	$self->{file_dir}  = $subdir;
	$self->{file_full} = $save_file;
	$self->{file_name} = $file_name;
	$self->{file_size} = $file_size;
	$self->{is_image}  = $is_image;
	#----------------------------------------------------------------------
	# 
	#----------------------------------------------------------------------
	my %h;
	$h{i} = $diary_id;
	$h{b} = $ROBJ->{Basepath};
	$h{u} = $self->{image_dir};
	$h{d} = $subdir;
	$h{f} = $file_name;
	$h{e} = $file_ex;
	$h{s} = $file_size;
	$h{h} = $ROBJ->{Server_url};
	$h{'%'} = '%';

	my $tag = $self->{upload_tag};
	if (! $is_image) {	# ʳ
		$self->{upload_file} = $self->{upload_file_full};
		$self->{upload_file} =~ s/%(\w)/$h{$1}/g;
		$self->{upload_file} =~ s/(["'<>])/'%' . unpack('H2',$1)/eg;
		$tag = $self->{upload_tag_etc};
	}
	$tag =~ s/%(\w)/$h{$1}/g;
	$self->{tag} = $tag;
	if (! $is_image) { return 0; }

	#----------------------------------------------------------------------
	# ImageMagic Ȥͥ
	#----------------------------------------------------------------------
	if (!$self->{make_thumbnail} || !$ROBJ->check_lib("Image::Magick")) { return 0; }
	require 'Image/Magick.pm';
	# ͥdirκ
	$dir .= $self->{upload_thumbnail_dir};
	$ROBJ->mkdir($dir);
	# ͥե
	$file_name .= '.jpg';
	my $thumbnail_file = $ROBJ->get_filepath( $dir . $file_name );

	my $image = Image::Magick->new;
	eval { $image->Read( $save_file_real ) };
	if ($@) { last; }	# load 
	$image->Set( quality => ($self->{jpeg_quality} || 60) );

	# ꥵ
	my ($width, $height) = $image->Get('width', 'height');
	my $size = $self->{thumbnail_size};
	if ($size < 16) { $size=120; }
	if ($width<$size && $height<$size) {
		$size = 0;	# resize ʤ
	} elsif ($width > $height) {
		$height = int($height*($size/$width));
		$width  = $size;
	} else {
		$width  = int($width*($size/$height));
		$height = $size;
	}
	if ($size) {	# ꥵ
		$image->Resize(width => $width, height => $height, blur => 0.7);
	}

	# ե˽񤭽Ф
	$image->Write($thumbnail_file);
	if ($ROBJ->{File_mode}) { chmod($ROBJ->{File_mode}, $thumbnail_file); }

	#----------------------------------------------------------------------
	# κ
	#----------------------------------------------------------------------
	$tag = $self->{upload_tag_thumbnail};
	if (!-r $thumbnail_file) {		# ͥ
		$tag = $self->{upload_tag};	# ɸλ
	}
	$tag =~ s/%(\w)/$h{$1}/g;
	$self->{tag} = $tag;
	return 0;	# 
}


1;	# ޤʤ
